/*!
* @file Discipline.h
* @brief C{̃vg^Cv錾
* @date 2014/03/04
* @author Deskull
* 2014 Sikabane Works.
*/

#pragma once

#include "stdafx.h"
#include "Deeangband.h"

namespace Deeangband
{

	/*!
	* @brief C{̗񋓑
	*/
	typedef enum DISCIPLINE_TYPE
	{
		DISCIPLINE_TYPE_GOOD,    //!< C{:P
		DISCIPLINE_TYPE_EVIL,    //!< C{:
		DISCIPLINE_TYPE_ORDER,   //!< C{:
		DISCIPLINE_TYPE_CHAOS,   //!< C{:
		DISCIPLINE_TYPE_BALANCE, //!< C{:V
		MAX_DISCIPLINE_TYPES,    //!< C{
	} DISCIPLINE_TYPE;


	/*! 
	* @class Discipline
	* @brief C{̃NX
	*/
	class Discipline
	{
	private:

		NAME name;
		int disciplinePoint[MAX_DISCIPLINE_TYPES];

		friend class boost::serialization::access;

		/*!
		* @brief NX̃VACYݒ肷
		* @param archive A[JCuNX̃AhX
		* @param version t@Co[W
		* @return XMLSerializeev[g
		*/
		template<class Archive> void serialize(Archive &archive, const unsigned int version) 
		{
			if(version <= 10)
			{
				archive & boost::serialization::make_nvp("Point", disciplinePoint);
			}
			else
			{
				archive & boost::serialization::make_nvp("Good", disciplinePoint[DISCIPLINE_TYPE_GOOD]);
				archive & boost::serialization::make_nvp("Evil", disciplinePoint[DISCIPLINE_TYPE_EVIL]);
				archive & boost::serialization::make_nvp("Order", disciplinePoint[DISCIPLINE_TYPE_ORDER]);
				archive & boost::serialization::make_nvp("Chaos", disciplinePoint[DISCIPLINE_TYPE_CHAOS]);
				archive & boost::serialization::make_nvp("Balance", disciplinePoint[DISCIPLINE_TYPE_BALANCE]);
			}
		}


	public:

		/*! 
		* @brief DisciplineNX̃RXgN^
		* @param good P̏C{l
		* @param evil ̏C{l
		* @param order ̏C{l
		* @param chaos ׂ̏C{l
		* @param balance V̏C{l
		*/
		Discipline::Discipline(int good, int evil, int order, int chaos, int balance);

		/*! 
		* @brief DisciplineNX̃RXgN^
		*/
		Discipline::Discipline(void);

		/*! 
		* @brief DisciplineNX̃fXgN^
		*/
		Discipline::~Discipline(void);

		/*! 
		* @brief C{l擾
		* @param typ C{l̎
		* @return C{l
		*/
		const DISCIPLINE_POINT Discipline::GetPoint(DISCIPLINE_TYPE typ);

		/*! 
		* @brief C{N擾
		* @param typ C{l̎
		* @return C{N
		*/
		const DISCIPLINE_POINT Discipline::GetRank(DISCIPLINE_TYPE typ);

		/*! 
		* @brief C{lݒ肷
		* @param typ C{l̎
		* @param point l
		* @return Ȃ
		*/
		void Discipline::SetPoint(DISCIPLINE_TYPE typ, int point);

		/*! 
		* @brief C{lݒ肷
		* @param good P̏C{l
		* @param evil ̏C{l
		* @param order ̏C{l
		* @param chaos ׂ̏C{l
		* @param balance V̏C{l
		* @return Ȃ
		*/
		void Discipline::SetPoint(int good, int evil, int order, int chaos, int balance);

		/*! 
		* @brief C{lZ
		* @param typ C{l̎
		* @param point Zl
		* @return Ȃ
		*/
		void Discipline::PlusPoint(DISCIPLINE_TYPE typ, int point);

		/*!
		* @brief +ZqɂC{lSZ
		* @param plus Z
		*/
		Discipline Discipline::operator+(const Discipline& plus);  

		/*!
		* @brief +=ZqɂC{lSZ
		* @param plus Z
		*/
		Discipline& Discipline::operator+=(const Discipline& plus);

		/*!
		* @brief C{Ԃ
		* @return C{
		*/
		std::string Discipline::GetName(void);

	};

}

BOOST_CLASS_VERSION(Deeangband::Discipline, 11);
