/*!
* @file Square.h
* @brief Q[̃}Xƕtvf̃vg^Cv
* @date 2013/12/11
* @author Deskull
* 2013 Sikabane Works.
*/

#pragma once

#include "stdafx.h"
#include "Deeangband.h"
#include "GameElement.h"
#include "HaveHp.h"
#include "HaveInventory.h"

namespace Deeangband
{
	class Floor;

	/*! 
	 * @class Square
	 * @brief }X̃NX
	 */
	class Square : public GameElement, public HaveInventory, public HaveHp
	{
	private:
		TAG floorTag;     //!<n`^O
		TAG spaceTag;     //!<Ԓn`^O
		TAG airTag;       //!<Cn`^O
		Floor *floorPtr;

		friend class boost::serialization::access;
		template<class Archive> void serialize(Archive &archive, const unsigned int) 
		{
			archive & boost::serialization::make_nvp("Floor", floorTag);
			archive & boost::serialization::make_nvp("HP", hitPoint);
			archive & boost::serialization::make_nvp("MaxHP", maxPoint);
		}

	public:

		/*! 
		* @brief SquareNXRXgN^
		*/
		Square::Square();

		Square::Square(std::map<TAG, boost::shared_ptr<Floor>>::iterator& floorIt);


		/*! 
		* @brief SquareNXfXgN^
		*/
		Square::~Square();

		/*! 
		* @brief _~[f[^ɂ鏉
		* @return Ȃ
		*/
		void Square::WipeData(void);

		/*!
		* @brief tÃ|C^ԂB
		*/
		Field* Square::GetFieldPtr(void);

		/*!
		 * @brief n`^OZbgB
		 * @param tag Zbg^O
		 * @return ^O̕ύXłꍇtrueԂB
		 * @todo K̃^Oǂ肷@\B
		 */
		bool Square::SetFloor(TAG tag);

		/*!
		 * @brief Ή鏰n`̃^OԂB
		 * @return Ή鏰n`^O
		 */
		TAG Square::GetFloorTag(void);

		/*!
		 * @brief Ή鏰n`̃^OԂB
		 * @return Ή鏰n`^O
		 */
		TAG Square::GetAirTag(void);

		/*!
		 * @brief ΉԒn`̃^OԂB
		 * @return Ή鏰n`^O
		 */
		TAG Square::GetSpaceTag(void);

		/*!
		 * @brief Ήn`̃|C^ԂB
		 * @return Ήn`̎Qƃ|C^
		 */
		Floor* Square::GetFloorPtr(void);

		/*!
		 * @brief n`ǂŎՕĂ邩Ԃ
		 * @return ՕĂȂ true
		 */
		bool Square::IsWall(void);


	};

}

BOOST_CLASS_VERSION(Deeangband::Square, 10);
